/* ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1/GPL 2.0/LGPL 2.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is AddressbooksSynchronizer.
 *
 * The Initial Developer of the Original Code is Gnter Gersdorf.
 * Portions created by the Initial Developer are Copyright (C) 2006
 * the Initial Developer. All Rights Reserved.
 *
 * Contributor(s):
 *  Gnter Gersdorf <G.Gersdorf@ggbs.de>
 *
 * Alternatively, the contents of this file may be used under the terms of
 * either the GNU General Public License Version 2 or later (the "GPL"), or
 * the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
 * in which case the provisions of the GPL or the LGPL are applicable instead
 * of those above. If you wish to allow use of your version of this file only
 * under the terms of either the GPL or the LGPL, and not to allow others to
 * use your version of this file under the terms of the MPL, indicate your
 * decision by deleting the provisions above and replace them with the notice
 * and other provisions required by the GPL or the LGPL. If you do not delete
 * the provisions above, a recipient may use your version of this file under
 * the terms of any one of the MPL, the GPL or the LGPL.
 *
 * ***** END LICENSE BLOCK ***** */

var strings;
var gPrefService = Components.classes["@mozilla.org/preferences-service;1"].
  getService(Components.interfaces.nsIPrefService);

var gInitDone=false;

function abs_init()
{
//gAddressbooksSync.doTest();

    var prefBranch = gPrefService.getBranch("extensions.addressbookssync.");

    strings = document.getElementById("ggbs_abs_strings");

    var syncpassword='';

    var synctype = gAddressbooksSync.synctype;
    var localpath = gAddressbooksSync.localpath;
    var syncprotocol = gAddressbooksSync.protocol;
    var synchost = gAddressbooksSync.host;
    var syncuser = gAddressbooksSync.user;
    //try{ syncpassword = get_password(synchost, syncuser); } catch(e){}
    syncpassword = '**********';
    var syncpath = gAddressbooksSync.path;
    var syncimap = gAddressbooksSync.imapfolder;
    var syncpolicy = gAddressbooksSync.syncpolicy;
    var imappolicy = gAddressbooksSync.imapusedraft;

    if (synctype=='local') {
      document.getElementById("synctype").selectedItem=document.getElementById("synclocal");
      document.getElementById("absTabs").selectedIndex=0;
      document.getElementById("absTab").selectedIndex=0;
    } else if (synctype=='remote') {
      document.getElementById("synctype").selectedItem=document.getElementById("syncremote");
      document.getElementById("absTabs").selectedIndex=1;
      document.getElementById("absTab").selectedIndex=1;
    } else if (synctype=='imap') {
      document.getElementById("synctype").selectedItem=document.getElementById("syncimap");
      document.getElementById("absTabs").selectedIndex=2;
      document.getElementById("absTab").selectedIndex=2;
    }

    document.getElementById("localpath").value = localpath;

    document.getElementById("protocol").value = syncprotocol;
    document.getElementById("host").value = synchost;
    document.getElementById("username").value = syncuser;
    document.getElementById("password").value = syncpassword;
    document.getElementById("path").value = syncpath;

    PickedMsgFolder(syncimap);

    document.getElementById("autoupload").checked = gAddressbooksSync.autoupload;
    document.getElementById("autodownload").checked = gAddressbooksSync.autodownload;
    document.getElementById("timedupload").checked = gAddressbooksSync.timedupload;
    document.getElementById("timeddownload").checked = gAddressbooksSync.timeddownload;
    document.getElementById("loadtimer").value = gAddressbooksSync.loadtimer;

    if (syncpolicy=='entry')
      document.getElementById("syncpolicy").selectedItem=document.getElementById("syncpolicyentry")
    else if (syncpolicy=='file')
      document.getElementById("syncpolicy").selectedItem=document.getElementById("syncpolicyfile")

    if (imappolicy)
      document.getElementById("imappolicy").selectedItem=document.getElementById("imappolicydraft")
    else
      document.getElementById("imappolicy").selectedItem=document.getElementById("imappolicyfile")
    document.getElementById("separateupdown").checked = gAddressbooksSync.separateupdown;

    var downloadpolicy=gAddressbooksSync.downloadpolicy;
    if (downloadpolicy=='ask')
      document.getElementById("downloadpolicy").selectedItem=document.getElementById("downloadpolicyask")
    else if (downloadpolicy=='overwrite')
      document.getElementById("downloadpolicy").selectedItem=document.getElementById("downloadpolicyoverwrite")
    else if (downloadpolicy=='keep')
      document.getElementById("downloadpolicy").selectedItem=document.getElementById("downloadpolicykeep")

    // list address books
    var mabList = document.getElementById("MabList");
    var mabList1 = document.getElementById("MabList1");
    var syncList = document.getElementById("SyncListCheck");
    //just in case
    mabList.removeAllItems();
    mabList1.removeAllItems();
    while (syncList.firstChild)
      syncList.removeChild(syncList.firstChild);
    document.getElementById("SyncLiscDesc").style.visibility =
      (gAddressbooksSync.separateupdown?'visible':'hidden');

    // get all MAB Files
    var selectedMAB='';
    var mabDirs=gAddressbooksSync.syncedAddressbooks('all','');
    for (var i = 0; i < mabDirs.Count(); i++) {
      var mabDir=mabDirs.GetElementAt(i).QueryInterface(Components.interfaces.nsIAbDirectory);
      var dirProp = gAddressbooksSync.TB3?mabDir:mabDir.directoryProperties;
      var prefName = gAddressbooksSync.TB3?dirProp.dirPrefId:dirProp.prefName;
      var description=mabDir.dirName;
      var mabFile=dirProp.fileName;

      mabList.appendItem( description, mabFile, "" ); // 'Store'
      mabList1.appendItem( description, mabFile, "" ); // 'Store'

      //'Sync'
      var hb=document.createElement('hbox');
      if (gAddressbooksSync.separateupdown) {
        var ncb1=document.createElement('checkbox');
        ncb1.setAttribute('id', 'addressbookssync_'+description+'_up');
        ncb1.setAttribute('label', null);
        hb.appendChild(ncb1);
      }
      var ncb=document.createElement('checkbox');
      ncb.setAttribute('id', 'addressbookssync_'+description);
      ncb.setAttribute('label', description);
      hb.appendChild(ncb);
      syncList.appendChild( hb );

      var sync=false;
      if (!gAddressbooksSync.separateupdown) {
        try { sync = prefBranch.getBoolPref( prefName+".down" ); } catch(e) { sync=false; }
        if (sync) {
          ncb.setAttribute('checked', true);
          selectedMAB=description;
        }
      } else {
        try { sync = prefBranch.getBoolPref( prefName+".up" ); } catch(e) { sync=false; }
        if (sync) {
          ncb1.setAttribute('checked', true);
          selectedMAB=description;
        }
        try { sync = prefBranch.getBoolPref( prefName+".down" ); } catch(e) { sync=false; }
        if (sync) {
          ncb.setAttribute('checked', true);
          selectedMAB=description;
        }
      }
    } // for
    mabList.selectedIndex = 0;
    mabList1.selectedIndex = 0;

    if (!selectedMAB) selectedMAB='???';
    selectedMAB+='.mab';
    document.getElementById("URI").value = getSyncURI(true)+selectedMAB;

    var usepost = gAddressbooksSync.usepost;
    document.getElementById("usepost").checked = usepost;

    document.getElementById("notimecheck").checked = !gAddressbooksSync.checkLastModTime;
    document.getElementById("hidepopups").checked = gAddressbooksSync.hidepopups;
    document.getElementById("hideallpopups").checked = gAddressbooksSync.hideallpopups;
    document.getElementById("noupload").checked = gAddressbooksSync.noupload;

    if (gAddressbooksSync.noupload) disableUpload();

    gInitDone=true;

} // init



function abs_finish()
{
    if (!gInitDone) return;

    var prefBranch = Components.classes["@mozilla.org/preferences-service;1"].
      getService(Components.interfaces.nsIPrefService).
      getBranch("extensions.addressbookssync.");

    if (!document.getElementById("localpath")) return;  // called via toolbar buttons

    var localpath=document.getElementById("localpath").value;
    gAddressbooksSync.localpath=localpath;
    if ( document.getElementById("synclocal").selected && localpath) {
      if (gAddressbooksSync.synctype!='local') {
        gAddressbooksSync.forceUpload=true;
        gAddressbooksSync.forceDownload=true;
      }
      gAddressbooksSync.synctype='local';
    } else if ( document.getElementById("syncremote").selected ) {
      if (gAddressbooksSync.synctype!='remote') {
        gAddressbooksSync.forceUpload=true;
        gAddressbooksSync.forceDownload=true;
      }
      gAddressbooksSync.synctype='remote';
    } else if ( document.getElementById("syncimap").selected ) {
      if (gAddressbooksSync.synctype!='imap') {
        gAddressbooksSync.forceUpload=true;
        gAddressbooksSync.forceDownload=true;
      }
      gAddressbooksSync.synctype='imap';
    } else {
      gAddressbooksSync.synctype='none';
      document.getElementById("synctype").selectedItem=null;
    }

    gAddressbooksSync.protocol=document.getElementById("protocol").value;
    var host=document.getElementById("host").value;  gAddressbooksSync.host=host;
    var user=document.getElementById("username").value; gAddressbooksSync.user=user;
    var pwd=document.getElementById("password").value;
    if (pwd!='**********') set_password(host,user,document.getElementById("password").value );
    gAddressbooksSync.path=document.getElementById("path").value;
    gAddressbooksSync.imapfolder=document.getElementById("syncimapPicker").getAttribute("uri");

    var v=document.getElementById("autoupload").checked;
    if (!gAddressbooksSync.autoupload && v) gAddressbooksSync.forceUpload=true;
    gAddressbooksSync.autoupload=v;
    v=document.getElementById("autodownload").checked;
    if (!gAddressbooksSync.autodownload && v) gAddressbooksSync.forceDownload=true;
    gAddressbooksSync.autodownload=v;

    gAddressbooksSync.timedupload=document.getElementById("timedupload").checked;
    gAddressbooksSync.timeddownload=document.getElementById("timeddownload").checked;
    var timer=gAddressbooksSync.loadtimer;
    gAddressbooksSync.loadtimer=document.getElementById("loadtimer").value;

    if ( document.getElementById("syncpolicyentry").selected)
      gAddressbooksSync.syncpolicy='entry';
    else if ( document.getElementById("syncpolicyfile").selected )
      gAddressbooksSync.syncpolicy='file';

    if ( document.getElementById("imappolicydraft").selected)
      gAddressbooksSync.imapusedraft=true;
    else if ( document.getElementById("imappolicyfile").selected )
      gAddressbooksSync.imapusedraft=false;

    if ( document.getElementById("downloadpolicyask").selected)
      gAddressbooksSync.downloadpolicy='ask';
    else if ( document.getElementById("downloadpolicyoverwrite").selected )
      gAddressbooksSync.downloadpolicy='overwrite';
    else if ( document.getElementById("downloadpolicykeep").selected )
      gAddressbooksSync.downloadpolicy='keep';

    var old_separateupdown=gAddressbooksSync.separateupdown;
    gAddressbooksSync.separateupdown=document.getElementById("separateupdown").checked;

    var selectedMab='???';
    var mabDirs=gAddressbooksSync.syncedAddressbooks('all', '');
    for (var i = 0; i < mabDirs.Count(); i++) {
      var mabDir=mabDirs.GetElementAt(i).QueryInterface(Components.interfaces.nsIAbDirectory);
      var dirProp = gAddressbooksSync.TB3?mabDir:mabDir.directoryProperties;
      var description=mabDir.dirName;
      var mabFile=dirProp.fileName;
      var prefName = gAddressbooksSync.TB3?dirProp.dirPrefId:dirProp.prefName;
      if (!old_separateupdown) {
        var syncElem = document.getElementById('addressbookssync_'+description);
        if (syncElem.getAttribute('checked')) {
          try { cbv=prefBranch.getBoolPref(prefName+".down"); } catch(e) { cbv=false; };
          gAddressbooksSync.forceUploadOf(mabFile, !cbv);
          prefBranch.setBoolPref( prefName+".down", true );
          prefBranch.setBoolPref( prefName+".up", true );
          selectedMAB=description;
        } else {
          prefBranch.setBoolPref( prefName+".down", false );
          prefBranch.setBoolPref( prefName+".up", false );
          gAddressbooksSync.forceUploadOf(mabFile, false);
        }
      } else {  // War separated
        var syncUpElem = document.getElementById('addressbookssync_'+description+'_up');
        var syncDownElem = document.getElementById('addressbookssync_'+description);
        if (!gAddressbooksSync.separateupdown) {  //jetzt aber nicht mehr!
          if (syncUpElem.getAttribute('checked') || syncDownElem.getAttribute('checked')) {
            // Wenn auch nur einer gechecked war: jetzt beide
            selectedMAB=description;
            gAddressbooksSync.forceUploadOf(mabFile, !prefBranch.getBoolPref(prefName+".up"));
            prefBranch.setBoolPref( prefName+".up", true );
            prefBranch.setBoolPref( prefName+".down", true );
          } else {
            gAddressbooksSync.forceUploadOf(mabFile, false);
            prefBranch.setBoolPref( prefName+".up", false );
            prefBranch.setBoolPref( prefName+".down", false );
          }
        } else {
          if (syncUpElem.getAttribute('checked')) {
            gAddressbooksSync.forceUploadOf(mabFile, !prefBranch.getBoolPref(prefName+".up"));
            prefBranch.setBoolPref( prefName+".up", true );
            selectedMAB=description;
          } else {
            prefBranch.setBoolPref( prefName+".up", false );
            gAddressbooksSync.forceUploadOf(mabFile, false);
          }
          if (syncDownElem.getAttribute('checked')) {
            prefBranch.setBoolPref( prefName+".down", true );
            selectedMAB=description;
          } else
            prefBranch.setBoolPref( prefName+".down", false );
        }
      }
    }
    if (typeof selectedMAB=='undefined') selectedMAB='???'; //warum tritt das gelegentlich auf?
    document.getElementById("URI").value = getSyncURI(true)+selectedMAB+'.mab';

    gAddressbooksSync.usepost=document.getElementById("usepost").checked;

    gAddressbooksSync.checkLastModTime=!document.getElementById("notimecheck").checked;
    gAddressbooksSync.hidepopups=document.getElementById("hidepopups").checked;
    gAddressbooksSync.hideallpopups=document.getElementById("hideallpopups").checked;
    gAddressbooksSync.noupload=document.getElementById("noupload").checked;

    pref.savePrefFile(null);  //save to prefs.js

    if (gAddressbooksSync.separateupdown!=old_separateupdown) abs_init(); // must rebuild!
} // finish



function ChooseFile()
{
  var nsIFilePicker = Components.interfaces.nsIFilePicker;
  var filePicker = Components.classes["@mozilla.org/filepicker;1"].createInstance(nsIFilePicker);

  var x=strings.getString("choosefile");
  filePicker.init(window, x, nsIFilePicker.modeOpen);
  filePicker.appendFilter( strings.getString("mab") + " (*.mab)", "*.mab;" );

  if( filePicker.show() == nsIFilePicker.returnOK )
  {
    document.getElementById( "MabFilePath" ).value = filePicker.file.path;
    var mabFileName = filePicker.file.leafName;
    var mabName = mabFileName.substr( 0, mabFileName.lastIndexOf(".") );
//    mabName = mabName.replace( /_/g, " " );
    document.getElementById( "MabName" ).value = mabName;
  }
} // ChooseFile

function ChoosePath()
{
  var nsIFilePicker = Components.interfaces.nsIFilePicker;
  var filePicker = Components.classes["@mozilla.org/filepicker;1"].createInstance(nsIFilePicker);

  filePicker.init(window, strings.getString("choosesyncdir"), nsIFilePicker.modeGetFolder);

  if( filePicker.show() == nsIFilePicker.returnOK )
  {
    document.getElementById( "localpath" ).value = filePicker.file.path;
    document.getElementById( "synctype" ).selectedItem=document.getElementById( "synclocal" );
  }
} // ChoosePath

function PickedMsgFolder(selection) {
  var selectedUri = typeof selection=="string"?selection:selection.getAttribute('id');

  var picker=document.getElementById('syncimapPicker');
  var msgfolder = GetMsgFolderFromUri(selectedUri, true);
//TODO: if (selectedFolder.server.type != "imap")

  if (!msgfolder)
    return;

  var selectedValue = null;
  var serverName;

  if (msgfolder.isServer)
    selectedValue = msgfolder.name;
  else {
    if (msgfolder.server)
      serverName = msgfolder.server.prettyName;
    else {
     dump("Can't find server for " + uri + "\n");
     serverName = "???";
    }
    var gMessengerBundle = document.getElementById("bundle_messenger");
    selectedValue = gMessengerBundle.getFormattedString("verboseFolderFormat",
        [msgfolder.name, serverName]);
  }

  picker.setAttribute("label",selectedValue);
  picker.setAttribute("uri",selectedUri);
}

function SaveMab()
{
    var mabFile = document.getElementById( "MabList" ).selectedItem.value;
    var mabName = document.getElementById( "MabList" ).selectedItem.label;

    var nsIFilePicker = Components.interfaces.nsIFilePicker;
    var filePicker = Components.classes["@mozilla.org/filepicker;1"].
      createInstance(nsIFilePicker);

//old    var externMabFileName = mabName.replace( /\W/g, "_" ) + ".mab";
    var externMabFileName = mabName + ".mab";
    filePicker.defaultString = externMabFileName;
    filePicker.init(window, strings.getString("choosefiledest"), nsIFilePicker.modeSave);
    filePicker.appendFilter( strings.getString("mab") + " (*.mab)", "*.mab;" );
//    filePicker.appendFilter( 'CSV' + " (*.csv)", "*.csv;" );
//    filePicker.appendFilter( 'LDIF' + " (*.ldif)", "*.ldif;" );

    if( filePicker.show() != nsIFilePicker.returnCancel) { //Ok or Replace!
      var ret;
      switch (filePicker.filterIndex) {
        case 0:
          ret=saveMabFile( mabName, mabFile, filePicker.file.parent, filePicker.file.leafName );
          break;
/*  leider sind die export Funktionen von Javascript aus nicht zugnglich :-(
    lediglich ab.exportAddressBook() ist verfgbar, aber das poppt ein
    FilePicker auf
*/
/*
        case 1:
          var cur=gAddressbooksSync.getAddressBook(mabFile);
          var ab = Components.classes["@mozilla.org/addressbook;1"].  //gibts in TB3 nicht mehr! ggf. in nsIAbManager
            getService(Components.interfaces.nsIAddressBookExport);
          var file=filePicker.file;
          //TODO: eventuell umbenennen statt lschen
          if (file.exists() && file.isFile()) { file.remove(false); }
          ret=ab.ExportDirectoryToDelimitedText(cur,';',1,file);
          break;
        case 2:
          var cur=gAddressbooksSync.getAddressBook(mabFile);
          var ab = Components.classes["@mozilla.org/addressbook;1"].  //gibts in TB3 nicht mehr! ggf. in nsIAbManager
            getService(Components.interfaces.nsIAddressBookExport);
          var file=filePicker.file;
          //TODO: eventuell umbenennen statt lschen
          if (file.exists() && file.isFile()) { file.remove(false); }
          ret=ab.ExportDirectoryToLDIF(cur,file);
          break;
*/
        default:
          ret=false;
          break;
      }
      if (ret)
        alert(strings.getString('stored'));
      else
        alert(strings.getString('storefailed'));
    }
} //
function UploadMab()
{ //upload single mab from options menu
    var mabFile = document.getElementById( "MabList1" ).selectedItem.value;
    var mabName = document.getElementById( "MabList1" ).selectedItem.label;
    showPopup('upload', mabFile, false, false, true);
}

function LoadMab()
{
  // see comment with secureAddressbook() in addressbookssync.js
  if (secureAddressbook()) {
    setTimeout(LoadMab, 1000); // give window time to close
    return;
  }

  var filename = document.getElementById( "MabFilePath" ).value;
  if (!filename) return;

  var mabName = document.getElementById( "MabName" ).value;
  if (!mabName) return;

  var mabFile='';
  var create;

  var cur=gAddressbooksSync.getAddressBook(mabName);
  if (cur) {
    var dirProp = gAddressbooksSync.TB3?cur:cur.directoryProperties;
    mabFile=dirProp.fileName;
    if (askOverwrite(cur, true)) return;
    create=false;
  } else {
    mabFile = mabName.replace( /\W/g, "_" )+'.mab';
    create=true;
  }
  file = Components.classes["@mozilla.org/file/local;1"].
    createInstance(Components.interfaces.nsILocalFile);
  try{ file.initWithPath( filename ); }
  catch(e) {
    alert(strings.getString('nofile'));
    file=null;
  }
  if (file) {
    var ret;
    if ((ret=replaceAddressBook(mabName, mabFile, file))) {
      alert(strings.getString('notcopied')+' '+ret);
      file=null;
    }
  }
  if (file) {
    document.getElementById( "MabFilePath" ).value='';
    document.getElementById( "MabName" ).value='';
    if (create) abs_init(); // insert in options list
    alert(strings.getString('loaded'));
  }
}
function DownloadMab()
{
  var mabName = document.getElementById( "DownloadMabName" ).value;
  if (!mabName) return;

  var mabFile='';

  var cur=gAddressbooksSync.getAddressBook(mabName);
  var create;
  if (cur) {
    var dirProp = gAddressbooksSync.TB3?cur:cur.directoryProperties;
    mabFile=dirProp.fileName;
    if (askOverwrite(cur, true)) return;
    create=false;
  } else {
dump('---downloading new!\n');
    mabFile = mabName;
    create=true;
  }

//  document.getElementById("UseMabFile").value=mabFile;
//  document.getElementById("MabCreated").setAttribute('checked', create);
  showPopup('download', mabFile, false, false, true);
//TODO: in download() sollte kein test auf file modification stattfinden

}

function get_password(host, user){
    var dhost= new Object();
    var duser= new Object();
    var pass= new Object();
    try{
      var pmInternal = Components.classes["@mozilla.org/passwordmanager;1"]
                      .createInstance(Components.interfaces.nsIPasswordManagerInternal);
      var ret=pmInternal.findPasswordEntry(host,user,"",dhost,duser,pass);
      return pass.value;
    }catch(e){}
    return "";
}

function set_password(host, user, pwd){
//alert('set_password');
    var passwordManager = Components.classes["@mozilla.org/passwordmanager;1"]
            .createInstance(Components.interfaces.nsIPasswordManager);
    try{
      passwordManager.removeUser(host,user);
    }catch(e){}
    passwordManager.addUser(host,user,pwd);
}

function uploadNow(force)
{//called via button click, not via automatic upload at end
  abs_finish(); //ggf genderte Parameter bernehmen!
  if (gAddressbooksSync.synctype!='none')
    showPopup('upload', null, false, false, force);
}

function downloadNow(force)
{//called via button click, not via automatic download at start
  abs_finish(); //ggf genderte Parameter bernehmen!
  if (gAddressbooksSync.synctype!='none')
    showPopup('download', null, false, false, force);
}

function uploadThis()
{ //called via context menu
  if (gAddressbooksSync.synctype!='none') {
    var abDir=GetSelectedDirectory(); //the URI
    var dir = GetDirectoryFromURI(abDir);
    var dirProp = gAddressbooksSync.TB3?dir:dir.directoryProperties;
    showPopup('upload', dirProp.fileName, false, false, true);
//    else  // also checked via events.js
//alert('upload in progress');
  }
}

function downloadThis()
{ //called via context menu
  if (gAddressbooksSync.synctype!='none') {
    var abDir=GetSelectedDirectory(); //the URI
    var dir = GetDirectoryFromURI(abDir);
    var dirProp = gAddressbooksSync.TB3?dir:dir.directoryProperties;
    showPopup('download', dirProp.fileName, false, false, true);
//    else  // also checked via events.js
//alert('download in progress');

  }
}
